# zest

Zest - the Ruby gem for the Pulp3 API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: v3
- Package version: 0.0.4
- Build package: io.swagger.codegen.languages.RubyClientCodegen

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build zest.gemspec
```

Then either install the gem locally:

```shell
gem install ./zest-0.0.4.gem
```
(for development, run `gem install --dev ./zest-0.0.4.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'zest', '~> 0.0.4'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/GIT_USER_ID/GIT_REPO_ID, then add the following in the Gemfile:

    gem 'zest', :git => 'https://github.com/GIT_USER_ID/GIT_REPO_ID.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'zest'

# Setup authorization
Zest.configure do |config|
  # Configure HTTP basic authorization: Basic
  config.username = 'YOUR USERNAME'
  config.password = 'YOUR PASSWORD'
end

api_instance = Zest::PulpApi.new

data = Zest::Artifact.new # Artifact | 


begin
  result = api_instance.artifacts_create(data)
  p result
rescue Zest::ApiError => e
  puts "Exception when calling PulpApi->artifacts_create: #{e}"
end

```

## Documentation for API Endpoints

All URIs are relative to *http://zest-builder*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*Zest::PulpApi* | [**artifacts_create**](docs/PulpApi.md#artifacts_create) | **POST** /pulp/api/v3/artifacts/ | 
*Zest::PulpApi* | [**artifacts_delete**](docs/PulpApi.md#artifacts_delete) | **DELETE** {artifact_href} | 
*Zest::PulpApi* | [**artifacts_list**](docs/PulpApi.md#artifacts_list) | **GET** /pulp/api/v3/artifacts/ | 
*Zest::PulpApi* | [**artifacts_read**](docs/PulpApi.md#artifacts_read) | **GET** {artifact_href} | 
*Zest::PulpApi* | [**content_file_files_create**](docs/PulpApi.md#content_file_files_create) | **POST** /pulp/api/v3/content/file/files/ | 
*Zest::PulpApi* | [**content_file_files_list**](docs/PulpApi.md#content_file_files_list) | **GET** /pulp/api/v3/content/file/files/ | 
*Zest::PulpApi* | [**content_file_files_read**](docs/PulpApi.md#content_file_files_read) | **GET** {file_content_href} | 
*Zest::PulpApi* | [**distributions_create**](docs/PulpApi.md#distributions_create) | **POST** /pulp/api/v3/distributions/ | 
*Zest::PulpApi* | [**distributions_delete**](docs/PulpApi.md#distributions_delete) | **DELETE** {distribution_href} | 
*Zest::PulpApi* | [**distributions_list**](docs/PulpApi.md#distributions_list) | **GET** /pulp/api/v3/distributions/ | 
*Zest::PulpApi* | [**distributions_partial_update**](docs/PulpApi.md#distributions_partial_update) | **PATCH** {distribution_href} | 
*Zest::PulpApi* | [**distributions_read**](docs/PulpApi.md#distributions_read) | **GET** {distribution_href} | 
*Zest::PulpApi* | [**distributions_update**](docs/PulpApi.md#distributions_update) | **PUT** {distribution_href} | 
*Zest::PulpApi* | [**orphans_delete**](docs/PulpApi.md#orphans_delete) | **DELETE** /pulp/api/v3/orphans/ | 
*Zest::PulpApi* | [**publications_delete**](docs/PulpApi.md#publications_delete) | **DELETE** {publication_href} | 
*Zest::PulpApi* | [**publications_list**](docs/PulpApi.md#publications_list) | **GET** /pulp/api/v3/publications/ | 
*Zest::PulpApi* | [**publications_read**](docs/PulpApi.md#publications_read) | **GET** {publication_href} | 
*Zest::PulpApi* | [**publishers_file_file_create**](docs/PulpApi.md#publishers_file_file_create) | **POST** /pulp/api/v3/publishers/file/file/ | 
*Zest::PulpApi* | [**publishers_file_file_delete**](docs/PulpApi.md#publishers_file_file_delete) | **DELETE** {file_publisher_href} | 
*Zest::PulpApi* | [**publishers_file_file_list**](docs/PulpApi.md#publishers_file_file_list) | **GET** /pulp/api/v3/publishers/file/file/ | 
*Zest::PulpApi* | [**publishers_file_file_partial_update**](docs/PulpApi.md#publishers_file_file_partial_update) | **PATCH** {file_publisher_href} | 
*Zest::PulpApi* | [**publishers_file_file_publish**](docs/PulpApi.md#publishers_file_file_publish) | **POST** {file_publisher_href}publish/ | 
*Zest::PulpApi* | [**publishers_file_file_read**](docs/PulpApi.md#publishers_file_file_read) | **GET** {file_publisher_href} | 
*Zest::PulpApi* | [**publishers_file_file_update**](docs/PulpApi.md#publishers_file_file_update) | **PUT** {file_publisher_href} | 
*Zest::PulpApi* | [**remotes_file_file_create**](docs/PulpApi.md#remotes_file_file_create) | **POST** /pulp/api/v3/remotes/file/file/ | 
*Zest::PulpApi* | [**remotes_file_file_delete**](docs/PulpApi.md#remotes_file_file_delete) | **DELETE** {file_remote_href} | 
*Zest::PulpApi* | [**remotes_file_file_list**](docs/PulpApi.md#remotes_file_file_list) | **GET** /pulp/api/v3/remotes/file/file/ | 
*Zest::PulpApi* | [**remotes_file_file_partial_update**](docs/PulpApi.md#remotes_file_file_partial_update) | **PATCH** {file_remote_href} | 
*Zest::PulpApi* | [**remotes_file_file_read**](docs/PulpApi.md#remotes_file_file_read) | **GET** {file_remote_href} | 
*Zest::PulpApi* | [**remotes_file_file_sync**](docs/PulpApi.md#remotes_file_file_sync) | **POST** {file_remote_href}sync/ | 
*Zest::PulpApi* | [**remotes_file_file_update**](docs/PulpApi.md#remotes_file_file_update) | **PUT** {file_remote_href} | 
*Zest::PulpApi* | [**repositories_create**](docs/PulpApi.md#repositories_create) | **POST** /pulp/api/v3/repositories/ | 
*Zest::PulpApi* | [**repositories_delete**](docs/PulpApi.md#repositories_delete) | **DELETE** {repository_href} | 
*Zest::PulpApi* | [**repositories_list**](docs/PulpApi.md#repositories_list) | **GET** /pulp/api/v3/repositories/ | 
*Zest::PulpApi* | [**repositories_partial_update**](docs/PulpApi.md#repositories_partial_update) | **PATCH** {repository_href} | 
*Zest::PulpApi* | [**repositories_read**](docs/PulpApi.md#repositories_read) | **GET** {repository_href} | 
*Zest::PulpApi* | [**repositories_update**](docs/PulpApi.md#repositories_update) | **PUT** {repository_href} | 
*Zest::PulpApi* | [**repositories_versions_create**](docs/PulpApi.md#repositories_versions_create) | **POST** {repository_href}versions/ | 
*Zest::PulpApi* | [**repositories_versions_delete**](docs/PulpApi.md#repositories_versions_delete) | **DELETE** {repository_version_href} | 
*Zest::PulpApi* | [**repositories_versions_list**](docs/PulpApi.md#repositories_versions_list) | **GET** {repository_href}versions/ | 
*Zest::PulpApi* | [**repositories_versions_partial_update**](docs/PulpApi.md#repositories_versions_partial_update) | **PATCH** {repository_version_href} | 
*Zest::PulpApi* | [**repositories_versions_read**](docs/PulpApi.md#repositories_versions_read) | **GET** {repository_version_href} | 
*Zest::PulpApi* | [**repositories_versions_update**](docs/PulpApi.md#repositories_versions_update) | **PUT** {repository_version_href} | 
*Zest::PulpApi* | [**status_list**](docs/PulpApi.md#status_list) | **GET** /pulp/api/v3/status/ | 
*Zest::PulpApi* | [**tasks_cancel**](docs/PulpApi.md#tasks_cancel) | **POST** {task_href}cancel/ | 
*Zest::PulpApi* | [**tasks_delete**](docs/PulpApi.md#tasks_delete) | **DELETE** {task_href} | 
*Zest::PulpApi* | [**tasks_list**](docs/PulpApi.md#tasks_list) | **GET** /pulp/api/v3/tasks/ | 
*Zest::PulpApi* | [**tasks_read**](docs/PulpApi.md#tasks_read) | **GET** {task_href} | 
*Zest::PulpApi* | [**uploads_create**](docs/PulpApi.md#uploads_create) | **POST** /pulp/api/v3/uploads/ | 
*Zest::PulpApi* | [**uploads_create_0**](docs/PulpApi.md#uploads_create_0) | **POST** {upload_href} | 
*Zest::PulpApi* | [**uploads_read**](docs/PulpApi.md#uploads_read) | **GET** /pulp/api/v3/uploads/ | 
*Zest::PulpApi* | [**uploads_read_0**](docs/PulpApi.md#uploads_read_0) | **GET** {upload_href} | 
*Zest::PulpApi* | [**uploads_update**](docs/PulpApi.md#uploads_update) | **PUT** /pulp/api/v3/uploads/ | 
*Zest::PulpApi* | [**uploads_update_0**](docs/PulpApi.md#uploads_update_0) | **PUT** {upload_href} | 
*Zest::PulpApi* | [**workers_list**](docs/PulpApi.md#workers_list) | **GET** /pulp/api/v3/workers/ | 
*Zest::PulpApi* | [**workers_read**](docs/PulpApi.md#workers_read) | **GET** {worker_href} | 


## Documentation for Models

 - [Zest::Artifact](docs/Artifact.md)
 - [Zest::AsyncOperationResponse](docs/AsyncOperationResponse.md)
 - [Zest::Distribution](docs/Distribution.md)
 - [Zest::FileContent](docs/FileContent.md)
 - [Zest::FilePublisher](docs/FilePublisher.md)
 - [Zest::FileRemote](docs/FileRemote.md)
 - [Zest::InlineResponse200](docs/InlineResponse200.md)
 - [Zest::InlineResponse2001](docs/InlineResponse2001.md)
 - [Zest::InlineResponse2002](docs/InlineResponse2002.md)
 - [Zest::InlineResponse2003](docs/InlineResponse2003.md)
 - [Zest::InlineResponse2004](docs/InlineResponse2004.md)
 - [Zest::InlineResponse2005](docs/InlineResponse2005.md)
 - [Zest::InlineResponse2006](docs/InlineResponse2006.md)
 - [Zest::InlineResponse2007](docs/InlineResponse2007.md)
 - [Zest::InlineResponse2008](docs/InlineResponse2008.md)
 - [Zest::InlineResponse2009](docs/InlineResponse2009.md)
 - [Zest::ProgressReport](docs/ProgressReport.md)
 - [Zest::Publication](docs/Publication.md)
 - [Zest::Repository](docs/Repository.md)
 - [Zest::RepositoryPublishURL](docs/RepositoryPublishURL.md)
 - [Zest::RepositorySyncURL](docs/RepositorySyncURL.md)
 - [Zest::RepositoryVersion](docs/RepositoryVersion.md)
 - [Zest::RepositoryVersionCreate](docs/RepositoryVersionCreate.md)
 - [Zest::Task](docs/Task.md)
 - [Zest::Upload](docs/Upload.md)
 - [Zest::Worker](docs/Worker.md)


## Documentation for Authorization


### Basic

- **Type**: HTTP basic authentication

